searchNodes=[{"ref":"OpenTelemetry.html","title":"OpenTelemetry","type":"module","doc":"An OpenTelemetry Trace consists of 1 or more Spans that either have a parent/child relationship or are linked together through a Link. Each Span has a TraceId (trace_id/0), SpanId (span_id/0), and a start and end time in nanoseconds. This module provides declaration of the types used throughout the library, as well as functions for building the additional pieces of a span that are optional. Each item can be attached to individual Span using the functions in OpenTelemetry.Span module. Example require OpenTelemetry.Tracer, as: Tracer Tracer.with_span &quot;some-span&quot; do event = OpenTelemetry.event(&quot;ecto.query&quot;, query: query, total_time: total_time) Tracer.add_events([event]) end"},{"ref":"OpenTelemetry.html#convert_timestamp/2","title":"OpenTelemetry.convert_timestamp/2","type":"function","doc":"Convert a native monotonic timestamp to POSIX time of any :erlang.time_unit/0. Meaning the time since Epoch. Epoch is defined to be 00:00:00 UTC, 1970-01-01."},{"ref":"OpenTelemetry.html#event/2","title":"OpenTelemetry.event/2","type":"function","doc":"Creates a event/0."},{"ref":"OpenTelemetry.html#event/3","title":"OpenTelemetry.event/3","type":"function","doc":"Creates a event/0."},{"ref":"OpenTelemetry.html#events/1","title":"OpenTelemetry.events/1","type":"function","doc":"Creates a list of event/0 items."},{"ref":"OpenTelemetry.html#get_tracer/1","title":"OpenTelemetry.get_tracer/1","type":"function","doc":"See :opentelemetry.get_tracer/1."},{"ref":"OpenTelemetry.html#get_tracer/3","title":"OpenTelemetry.get_tracer/3","type":"function","doc":"See :opentelemetry.get_tracer/3."},{"ref":"OpenTelemetry.html#link/1","title":"OpenTelemetry.link/1","type":"function","doc":"Creates a link/0 from a span_ctx/0."},{"ref":"OpenTelemetry.html#link/2","title":"OpenTelemetry.link/2","type":"function","doc":"Creates a link/0 from a span_ctx/0 and list of attributes_map/0."},{"ref":"OpenTelemetry.html#link/4","title":"OpenTelemetry.link/4","type":"function","doc":"Creates a link/0."},{"ref":"OpenTelemetry.html#links/1","title":"OpenTelemetry.links/1","type":"function","doc":"Creates a list of link/0 from a list of 4-tuples."},{"ref":"OpenTelemetry.html#set_default_tracer/1","title":"OpenTelemetry.set_default_tracer/1","type":"function","doc":"See :opentelemetry.set_default_tracer/1."},{"ref":"OpenTelemetry.html#status/2","title":"OpenTelemetry.status/2","type":"function","doc":"Creates a Status."},{"ref":"OpenTelemetry.html#timestamp/0","title":"OpenTelemetry.timestamp/0","type":"function","doc":"A monotonically increasing time provided by the Erlang runtime system in the native time unit. This value is the most accurate and precise timestamp available from the Erlang runtime and should be used for finding durations or any timestamp that can be converted to a system time before being sent to another system. Use convert_timestamp/2 or timestamp_to_nano/1 to convert a native monotonic time to a system time of either nanoseconds or another unit. Using these functions allows timestamps to be accurate, used for duration and be exportable as POSIX time when needed."},{"ref":"OpenTelemetry.html#timestamp_to_nano/1","title":"OpenTelemetry.timestamp_to_nano/1","type":"function","doc":"Convert a native monotonic timestamp to nanosecond POSIX time. Meaning the time since Epoch. Epoch is defined to be 00:00:00 UTC, 1970-01-01."},{"ref":"OpenTelemetry.html#t:attribute_key/0","title":"OpenTelemetry.attribute_key/0","type":"type","doc":""},{"ref":"OpenTelemetry.html#t:attribute_value/0","title":"OpenTelemetry.attribute_value/0","type":"type","doc":""},{"ref":"OpenTelemetry.html#t:attributes_map/0","title":"OpenTelemetry.attributes_map/0","type":"type","doc":"Attributes are a collection of key/value pairs. The value can be a string, an integer, a double or the boolean values true or false. Note, global attributes like server name can be set using the resource API. Examples of attributes: [{&quot;/http/user_agent&quot; &quot;Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36&quot;} {&quot;/http/server_latency&quot;, 300} {&quot;abc.com/myattribute&quot;, True} {&quot;abc.com/score&quot;, 10.239}]"},{"ref":"OpenTelemetry.html#t:event/0","title":"OpenTelemetry.event/0","type":"type","doc":"An Event is a time-stamped annotation of the span, consisting of user-supplied text description and key-value pairs."},{"ref":"OpenTelemetry.html#t:event_name/0","title":"OpenTelemetry.event_name/0","type":"type","doc":""},{"ref":"OpenTelemetry.html#t:link/0","title":"OpenTelemetry.link/0","type":"type","doc":"A Link is a pointer from the current span to another span in the same trace or in a different trace. For example, this can be used in batching operations, where a single batch handler processes multiple requests from different traces or when the handler receives a request from a different project."},{"ref":"OpenTelemetry.html#t:span/0","title":"OpenTelemetry.span/0","type":"type","doc":"Span represents a single operation within a trace. Spans can be nested to form a trace tree. Spans may also be linked to other spans from the same or different trace and form graphs. Often, a trace contains a root span that describes the end-to-end latency, and one or more subspans for its sub-operations. A trace can also contain multiple root spans, or none at all. Spans do not need to be contiguous - there may be gaps or overlaps between spans in a trace."},{"ref":"OpenTelemetry.html#t:span_ctx/0","title":"OpenTelemetry.span_ctx/0","type":"type","doc":"A SpanContext represents the portion of a Span needed to do operations on a Span. Within a process it acts as a key for looking up and modifying the actual Span. It is also what is serialized and propagated across process boundaries."},{"ref":"OpenTelemetry.html#t:span_id/0","title":"OpenTelemetry.span_id/0","type":"type","doc":"SpanId is a unique identifier for a span within a trace, assigned when the span is created. The ID is an 8-byte array. An ID with all zeroes is considered invalid."},{"ref":"OpenTelemetry.html#t:span_kind/0","title":"OpenTelemetry.span_kind/0","type":"type","doc":""},{"ref":"OpenTelemetry.html#t:span_name/0","title":"OpenTelemetry.span_name/0","type":"type","doc":""},{"ref":"OpenTelemetry.html#t:status/0","title":"OpenTelemetry.status/0","type":"type","doc":"An optional final status for this span. Semantically when Status wasn't set it means span ended without errors and assume unset. Application developers may set the status as ok when the operation has been validated to have completed successfully."},{"ref":"OpenTelemetry.html#t:trace_id/0","title":"OpenTelemetry.trace_id/0","type":"type","doc":"TraceId is a unique identifier for a trace. All spans from the same trace share the same trace_id. The ID is a 16-byte array. An ID with all zeroes is considered invalid."},{"ref":"OpenTelemetry.html#t:tracestate/0","title":"OpenTelemetry.tracestate/0","type":"type","doc":"Tracestate represents tracing-system specific context in a list of key-value pairs. Tracestate allows different vendors propagate additional information and inter-operate with their legacy Id formats. It is a tracestate in the w3c-trace-context format. See also https://github.com/w3c/distributed-tracing for more details about this field."},{"ref":"OpenTelemetry.Baggage.html","title":"OpenTelemetry.Baggage","type":"module","doc":"Baggage is used to annotate telemetry, adding context and information to metrics, traces, and logs. It is represented by a set of name/value pairs describing user-defined properties."},{"ref":"OpenTelemetry.Baggage.html#clear/0","title":"OpenTelemetry.Baggage.clear/0","type":"function","doc":"See :otel_baggage.clear/0."},{"ref":"OpenTelemetry.Baggage.html#clear/1","title":"OpenTelemetry.Baggage.clear/1","type":"function","doc":"See :otel_baggage.clear/1."},{"ref":"OpenTelemetry.Baggage.html#get_all/0","title":"OpenTelemetry.Baggage.get_all/0","type":"function","doc":"See :otel_baggage.get_all/0."},{"ref":"OpenTelemetry.Baggage.html#get_all/1","title":"OpenTelemetry.Baggage.get_all/1","type":"function","doc":"See :otel_baggage.get_all/1."},{"ref":"OpenTelemetry.Baggage.html#set/1","title":"OpenTelemetry.Baggage.set/1","type":"function","doc":"See :otel_baggage.set/1."},{"ref":"OpenTelemetry.Baggage.html#set/2","title":"OpenTelemetry.Baggage.set/2","type":"function","doc":"See :otel_baggage.set/2."},{"ref":"OpenTelemetry.Baggage.html#set/3","title":"OpenTelemetry.Baggage.set/3","type":"function","doc":"See :otel_baggage.set/3."},{"ref":"OpenTelemetry.Baggage.html#set/4","title":"OpenTelemetry.Baggage.set/4","type":"function","doc":"See :otel_baggage.set/4."},{"ref":"OpenTelemetry.Ctx.html","title":"OpenTelemetry.Ctx","type":"module","doc":"Ctx is responsible for propagating values within a process that are associated with a particular Trace or set of Baggage. OpenTelemetry.Tracer and OpenTelemetry.Baggage handle updating the Context."},{"ref":"OpenTelemetry.Ctx.html#attach/1","title":"OpenTelemetry.Ctx.attach/1","type":"function","doc":"See :otel_ctx.attach/1."},{"ref":"OpenTelemetry.Ctx.html#clear/0","title":"OpenTelemetry.Ctx.clear/0","type":"function","doc":"See :otel_ctx.clear/0."},{"ref":"OpenTelemetry.Ctx.html#detach/1","title":"OpenTelemetry.Ctx.detach/1","type":"function","doc":"See :otel_ctx.detach/1."},{"ref":"OpenTelemetry.Ctx.html#get_current/0","title":"OpenTelemetry.Ctx.get_current/0","type":"function","doc":"See :otel_ctx.get_current/0."},{"ref":"OpenTelemetry.Ctx.html#get_value/2","title":"OpenTelemetry.Ctx.get_value/2","type":"function","doc":"See :otel_ctx.get_value/2."},{"ref":"OpenTelemetry.Ctx.html#get_value/3","title":"OpenTelemetry.Ctx.get_value/3","type":"function","doc":"See :otel_ctx.get_value/3."},{"ref":"OpenTelemetry.Ctx.html#new/0","title":"OpenTelemetry.Ctx.new/0","type":"function","doc":"See :otel_ctx.new/0."},{"ref":"OpenTelemetry.Ctx.html#remove/1","title":"OpenTelemetry.Ctx.remove/1","type":"function","doc":"See :otel_ctx.remove/1."},{"ref":"OpenTelemetry.Ctx.html#set_value/2","title":"OpenTelemetry.Ctx.set_value/2","type":"function","doc":"See :otel_ctx.set_value/2."},{"ref":"OpenTelemetry.Ctx.html#set_value/3","title":"OpenTelemetry.Ctx.set_value/3","type":"function","doc":"See :otel_ctx.set_value/3."},{"ref":"OpenTelemetry.Ctx.html#t:t/0","title":"OpenTelemetry.Ctx.t/0","type":"type","doc":""},{"ref":"OpenTelemetry.Span.html","title":"OpenTelemetry.Span","type":"module","doc":"This module contains macros for Span operations that update the active current Span in the current process. An example of creating an Event and adding it to the current Span: require OpenTelemetry.Tracer, as: Tracer require OpenTelemetry.Span, as: Span span_ctx = Tracer.start_span(&quot;some-span&quot;) ... Span.add_event(span_ctx, &quot;ecto.query&quot;, query: query, total_time: total_time) ... Span.end_span(span_ctx) A Span represents a single operation within a trace. Spans can be nested to form a trace tree. Each trace contains a root span, which typically describes the end-to-end latency and, optionally, one or more sub-spans for its sub-operations. Spans encapsulate: The span name An immutable SpanContext (OpenTelemetry.span_ctx/0) that uniquely identifies the Span A parent Span in the form of a Span (OpenTelemetry.span/0), SpanContext (OpenTelemetry.span_ctx/0), or undefined A start timestamp An end timestamp An ordered mapping of Attributes (OpenTelemetry.attributes_map/0) A list of Links to other Spans (OpenTelemetry.link/0) A list of timestamped Events (OpenTelemetry.event/0) A Status (OpenTelemetry.status/0)"},{"ref":"OpenTelemetry.Span.html#add_event/3","title":"OpenTelemetry.Span.add_event/3","type":"function","doc":"Add an event to the currently active Span."},{"ref":"OpenTelemetry.Span.html#add_events/2","title":"OpenTelemetry.Span.add_events/2","type":"function","doc":"Add a list of events to the currently active Span."},{"ref":"OpenTelemetry.Span.html#end_span/1","title":"OpenTelemetry.Span.end_span/1","type":"function","doc":"End the Span. Sets the end timestamp for the currently active Span. This has no effect on any child Spans that may exist of this Span. The Span Context is returned with is_recording set to false."},{"ref":"OpenTelemetry.Span.html#end_span/2","title":"OpenTelemetry.Span.end_span/2","type":"function","doc":"End the Span. Sets the end timestamp for the currently active Span using the passed in timestamp if valid, current timestamp otherwise. This has no effect on any child Spans that may exist of this Span. The Span Context is returned with is_recording set to false."},{"ref":"OpenTelemetry.Span.html#hex_span_id/1","title":"OpenTelemetry.Span.hex_span_id/1","type":"function","doc":"Get the lowercase hex encoded span ID."},{"ref":"OpenTelemetry.Span.html#hex_trace_id/1","title":"OpenTelemetry.Span.hex_trace_id/1","type":"function","doc":"Get the lowercase hex encoded trace ID."},{"ref":"OpenTelemetry.Span.html#is_recording/1","title":"OpenTelemetry.Span.is_recording/1","type":"function","doc":""},{"ref":"OpenTelemetry.Span.html#is_valid/1","title":"OpenTelemetry.Span.is_valid/1","type":"function","doc":""},{"ref":"OpenTelemetry.Span.html#record_exception/4","title":"OpenTelemetry.Span.record_exception/4","type":"function","doc":"Record an exception as an event, following the semantics convetions for exceptions. If trace is not provided, the stacktrace is retrieved from Process.info/2"},{"ref":"OpenTelemetry.Span.html#set_attribute/3","title":"OpenTelemetry.Span.set_attribute/3","type":"function","doc":"Set an attribute with key and value on the currently active Span."},{"ref":"OpenTelemetry.Span.html#set_attributes/2","title":"OpenTelemetry.Span.set_attributes/2","type":"function","doc":"Add a list of attributes to the currently active Span."},{"ref":"OpenTelemetry.Span.html#set_status/2","title":"OpenTelemetry.Span.set_status/2","type":"function","doc":"Sets the Status of the currently active Span. If used, this will override the default Span Status, which is :unset."},{"ref":"OpenTelemetry.Span.html#span_id/1","title":"OpenTelemetry.Span.span_id/1","type":"function","doc":"Get the SpanId of a Span."},{"ref":"OpenTelemetry.Span.html#trace_id/1","title":"OpenTelemetry.Span.trace_id/1","type":"function","doc":"Get the TraceId of a Span."},{"ref":"OpenTelemetry.Span.html#tracestate/1","title":"OpenTelemetry.Span.tracestate/1","type":"function","doc":"Get the Tracestate of a Span."},{"ref":"OpenTelemetry.Span.html#update_name/2","title":"OpenTelemetry.Span.update_name/2","type":"function","doc":"Updates the Span name. It is highly discouraged to update the name of a Span after its creation. Span name is often used to group, filter and identify the logical groups of spans. And often, filtering logic will be implemented before the Span creation for performance reasons. Thus the name update may interfere with this logic. The function name is called UpdateName to differentiate this function from the regular property setter. It emphasizes that this operation signifies a major change for a Span and may lead to re-calculation of sampling or filtering decisions made previously depending on the implementation."},{"ref":"OpenTelemetry.Span.html#t:start_opts/0","title":"OpenTelemetry.Span.start_opts/0","type":"type","doc":""},{"ref":"OpenTelemetry.Tracer.html","title":"OpenTelemetry.Tracer","type":"module","doc":"This module contains macros for Tracer operations around the lifecycle of the Spans within a Trace. The Tracer is able to start a new Span as a child of the active Span of the current process, set a different Span to be the current Span by passing the Span's context, end a Span or run a code block within the context of a newly started span that is ended when the code block completes. The macros start_span and with_span use the Tracer associated with the Application the module is included in. These Tracers are created at boot time for each loaded Application. require OpenTelemetry.Tracer, as: Tracer Tracer.with_span &quot;span-1&quot; do ... do something ... end"},{"ref":"OpenTelemetry.Tracer.html#add_event/2","title":"OpenTelemetry.Tracer.add_event/2","type":"function","doc":"Add an event to the currently active Span."},{"ref":"OpenTelemetry.Tracer.html#add_events/1","title":"OpenTelemetry.Tracer.add_events/1","type":"function","doc":"Add a list of events to the currently active Span."},{"ref":"OpenTelemetry.Tracer.html#current_span_ctx/0","title":"OpenTelemetry.Tracer.current_span_ctx/0","type":"function","doc":"Returns the currently active OpenTelemetry.span_ctx/0."},{"ref":"OpenTelemetry.Tracer.html#current_span_ctx/1","title":"OpenTelemetry.Tracer.current_span_ctx/1","type":"function","doc":"Returns the OpenTelemetry.span_ctx/0 active in Context ctx."},{"ref":"OpenTelemetry.Tracer.html#end_span/1","title":"OpenTelemetry.Tracer.end_span/1","type":"function","doc":"End the Span. Sets the end timestamp for the currently active Span. This has no effect on any child Spans that may exist of this Span. The Span in the current Context has its is_recording set to false."},{"ref":"OpenTelemetry.Tracer.html#set_attribute/2","title":"OpenTelemetry.Tracer.set_attribute/2","type":"function","doc":"Set an attribute with key and value on the currently active Span."},{"ref":"OpenTelemetry.Tracer.html#set_attributes/1","title":"OpenTelemetry.Tracer.set_attributes/1","type":"function","doc":"Add a list of attributes to the currently active Span."},{"ref":"OpenTelemetry.Tracer.html#set_current_span/1","title":"OpenTelemetry.Tracer.set_current_span/1","type":"function","doc":"Takes a OpenTelemetry.span_ctx/0 and the Tracer sets it to the currently active Span."},{"ref":"OpenTelemetry.Tracer.html#set_current_span/2","title":"OpenTelemetry.Tracer.set_current_span/2","type":"function","doc":"Takes a OpenTelemetry.Ctx.t/0 and the OpenTelemetry.span_ctx/0 and the Tracer sets it to the current span in the pass Context."},{"ref":"OpenTelemetry.Tracer.html#set_status/1","title":"OpenTelemetry.Tracer.set_status/1","type":"function","doc":"Sets the Status of the currently active Span. If used, this will override the default Span Status, which is :unset."},{"ref":"OpenTelemetry.Tracer.html#start_span/2","title":"OpenTelemetry.Tracer.start_span/2","type":"macro","doc":"Starts a new span and does not make it the current active span of the current process. The current active Span is used as the parent of the created Span."},{"ref":"OpenTelemetry.Tracer.html#start_span/3","title":"OpenTelemetry.Tracer.start_span/3","type":"macro","doc":"Starts a new span and does not make it the current active span of the current process. The current active Span is used as the parent of the created Span."},{"ref":"OpenTelemetry.Tracer.html#update_name/1","title":"OpenTelemetry.Tracer.update_name/1","type":"function","doc":"Updates the Span name. It is highly discouraged to update the name of a Span after its creation. Span name is often used to group, filter and identify the logical groups of spans. And often, filtering logic will be implemented before the Span creation for performance reasons. Thus the name update may interfere with this logic. The function name is called UpdateName to differentiate this function from the regular property setter. It emphasizes that this operation signifies a major change for a Span and may lead to re-calculation of sampling or filtering decisions made previously depending on the implementation."},{"ref":"OpenTelemetry.Tracer.html#with_span/3","title":"OpenTelemetry.Tracer.with_span/3","type":"macro","doc":"Creates a new span which is set to the currently active Span in the Context of the block. The Span is ended automatically when the block completes and the Context is what it was before the block. See start_span/2 and end_span/0."},{"ref":"OpenTelemetry.Tracer.html#with_span/4","title":"OpenTelemetry.Tracer.with_span/4","type":"macro","doc":"Creates a new span which is set to the currently active Span in the Context of the block. The Span is ended automatically when the block completes and the Context is what it was before the block. See start_span/2 and end_span/0."},{"ref":"readme.html","title":"Overview","type":"extras","doc":"Erlang/Elixir OpenTelemetry API This is the API portion of OpenTelemetry for Erlang and Elixir Applications, implementing the API portion of the specification. This is a library, it does not start any processes, and should be the only OpenTelemetry dependency of Erlang/Elixir Applications."},{"ref":"readme.html#use","title":"Overview - Use","type":"extras","doc":"There are both Erlang and Elixir macros that make use of the current module's name to lookup a Named Tracer -- a Named Tracer is created for each Application loaded in the system at start time -- for you and can be used for Trace and Span operations: -include_lib(&quot;opentelemetry_api/include/otel_tracer.hrl&quot;). some_fun() -&gt; ?with_span(&lt;&lt;&quot;some_fun/0&quot;&gt;&gt;, \#{}, fun(_SpanCtx) -&gt; ... ?set_attribute(&lt;&lt;&quot;key&quot;&gt;&gt;, &lt;&lt;&quot;value&quot;&gt;&gt;), ... end), require OpenTelemetry.Tracer require OpenTelemetry.Span def some_fun() do OpenTelemetry.Tracer.with_span &quot;some-span&quot; do ... OpenTelemetry.Span.set_attribute(&quot;key&quot;, &quot;value&quot;) ... end end Including the OpenTelemetry SDK When only the API is available at runtime a no-op Tracer is used and no Traces are exported. The OpenTelemetry SDK provides the functionality of Tracers, Span Processors and Exporters and should be included as part of a Release and not as a dependency of any individual Application. Exporters Included in the same Github repo as the API and SDK are an exporter for the OpenTelemetry Protocol (OTLP) and Zipkin: OpenTelemetry Protocol Zipkin Integrations Instrumentations of many popular Erlang and Elixir projects can be found in the contrib repo and on hex.pm under the OpenTelemetry organization."},{"ref":"readme.html#contributing","title":"Overview - Contributing","type":"extras","doc":"See the contributing file."}]